{-# OPTIONS --type-in-type #-}

open import NeilPrelude
open import Data.Bool
open import Class.Eq

module Class.Ord where

record Ord (A : Set) : Set where
  field _<=_ : A → A → Bool

  _<_     : A → A → Bool
  a < b   = not (b <= a)

  _>_     : A → A → Bool
  a > b   = b < a

  _>=_    : A → A → Bool
  a >= b  = b <= a

  _⊔_     : A → A → A
  a ⊔ b   = if a <= b then b else a

  _⊓_     : A → A → A
  a ⊓ b   = if a <= b then a else b

  infixr 5 _⊔_
  infixr 6 _⊓_
  infix  8 _<=_ _<_ _>=_ _>_

open module OrdInst {A} {{ ordA : Ord A }} = Ord ordA public

ltbool : Bool → Bool → Bool
ltbool false c = not c
ltbool true  c = c

ordBool : Ord Bool
ordBool = record { _<=_ = ltbool }
