{-# OPTIONS --type-in-type #-}

open import NeilPrelude


module CommRing {A : Set}

       (_⊕_    : Op A)
       (⊕assoc : Associative _⊕_)
       (⊕comm  : Commutative _⊕_)

       (zero  : A)
       (unit⊕ : UnitL zero _⊕_)

       (inverse : A → A)
       (⊕inverse : InverseR inverse zero _⊕_)

       (_⊗_    : Op A)
       (⊗assoc : Associative _⊗_)
       (⊗comm  : Commutative _⊗_)

       (one   : A)
       (unit⊗ : UnitL one _⊗_)

       (distrL : DistributiveL _⊗_ _⊕_)
  where

-- copied from CommSemiring as we can't have mutually recursive modules

⊗unit' : UnitR one _⊗_
⊗unit' = trans ⊗comm unit⊗

distrR' : DistributiveR _⊗_ _⊕_
distrR' = trans2 ⊗comm distrL (cong2 _⊕_ ⊗comm ⊗comm)

--

import RingUnity
open RingUnity _⊕_ ⊕assoc ⊕comm zero unit⊕ inverse ⊕inverse _⊗_ ⊗assoc one unit⊗ ⊗unit' distrL distrR'

import CommSemiRing
open CommSemiRing _⊕_ ⊕assoc ⊕comm zero unit⊕ _⊗_ ⊗assoc ⊗comm zero⊗ one unit⊗ distrL public


