{-# OPTIONS --type-in-type #-}

open import NeilPrelude
open import Properties

module CommSemiRing {A : Set}


       (_⊕_    : Op A)
       (⊕assoc : Associative _⊕_)
       (⊕comm  : Commutative _⊕_)

       (zero  : A)
       (unit⊕ : UnitL zero _⊕_)

       (_⊗_    : Op A)
       (⊗assoc : Associative _⊗_)
       (⊗comm  : Commutative _⊗_)

       (zero⊗ : ZeroL zero _⊗_)

       (one   : A)
       (unit⊗ : UnitL one _⊗_)

       (distrL : DistributiveL _⊗_ _⊕_)

  where

import CommMonoid
open CommMonoid _⊗_ ⊗assoc ⊗comm one

⊗zero : ZeroR zero _⊗_
⊗zero = trans ⊗comm zero⊗

⊗unit : UnitR one _⊗_
⊗unit = ⊕unit unit⊗

distrR : DistributiveR _⊗_ _⊕_
distrR = trans2 ⊗comm distrL (cong2 _⊕_ ⊗comm ⊗comm)

import SemiRingUnity
open SemiRingUnity _⊕_ ⊕assoc ⊕comm zero unit⊕ _⊗_ ⊗assoc zero⊗ ⊗zero one unit⊗ ⊗unit distrL distrR public

