{-# OPTIONS --type-in-type #-}

open import NeilPrelude
open import Class.Eq
open import Class.Ord
open import Data.Nat

module Data.Integer where

-----------------------------------------------

data ℤ : Set where
  +S : ℕ → ℤ
  Z  : ℤ
  -S : ℕ → ℤ

-----------------------------------------------

pred : ℤ → ℤ
pred (+S O)     = Z
pred (+S (S n)) = +S n
pred Z          = -S O
pred (-S n)     = -S (S n)

-----------------------------------------------

primint : ℤ → ℤ → Bool
primint Z Z           = true
primint (+S m) (+S n) = m == n
primint (-S m) (-S n) = m == n
primint _ _           = false

eqInt : Eq ℤ
eqInt = record { _==_ = primint }

ltint : ℤ → ℤ → Bool
ltint (+S m) (+S n) = m <= n
ltint (+S _) Z = false
ltint (+S _) (-S _) = false
ltint Z (+S _) = true
ltint Z Z = true
ltint Z (-S _) = false
ltint (-S _) (+S _) = true
ltint (-S _) Z = true
ltint (-S m) (-S n) = m >= n

ordInt : Ord ℤ
ordInt = record { _<=_ = ltint }

-----------------------------------------------
