{-# OPTIONS --type-in-type #-}

open import NeilPrelude

module DivisionRing {A : Set}

       (_⊕_    : Op A)
       (⊕assoc : Associative _⊕_)
       (⊕comm  : Commutative _⊕_)

       (zero  : A)
       (unit⊕ : UnitL zero _⊕_)

       (minus : A → A)
       (⊕inverse : InverseR minus zero _⊕_)

       (_⊗_    : Op A)
       (⊗assoc : Associative _⊗_)

       (one   : A)
       (unit⊗ : UnitL one _⊗_)
       (⊗unit : UnitR one _⊗_)

       (divide   : A → A)
       (⊗inverse : InverseR divide one _⊗_)
       (inverse⊗ : InverseL divide one _⊗_)

       (distrL : DistributiveL _⊗_ _⊕_)
       (distrR : DistributiveR _⊗_ _⊕_)

  where

import RingUnity
open RingUnity  _⊕_ ⊕assoc ⊕comm zero unit⊕ minus ⊕inverse _⊗_ ⊗assoc one unit⊗ ⊗unit distrL distrR public