{-# OPTIONS --type-in-type #-}

open import NeilPrelude

module Group {A : Set}

       (_⊕_ : Op A)
       (assoc : Associative _⊕_)
      
       (unit  : A)
       (unit⊕ : UnitL unit _⊕_)
       (⊕unit : UnitR unit _⊕_)
       
       (inverse : A → A)
       (⊕inverse : InverseR inverse unit _⊕_)
       (inverse⊕ : InverseL inverse unit _⊕_)

  where

import Monoid
open Monoid _⊕_ assoc unit unit⊕ ⊕unit public

import SemiGroup
open SemiGroup _⊕_ assoc public

import Equational
open Equational _≡_ refl trans

⊕eq' : CancellativeL _⊕_
⊕eq' {a} {b} {c} eq =

                 b
                        ⟨ sym unit⊕ ⟩
                 unit ⊕ b
                        ⟨ cong2R _⊕_ (sym inverse⊕) ⟩
                 (inverse a ⊕ a) ⊕ b
                        ⟨ assoc ⟩
                 inverse a ⊕ (a ⊕ b)
                        ⟨ cong2L _⊕_ eq ⟩
                 inverse a ⊕ (a ⊕ c)
                        ⟨ sym assoc ⟩
                 (inverse a ⊕ a) ⊕ c
                        ⟨ cong2R _⊕_ inverse⊕ ⟩
                 unit ⊕ c
                        ⟨ unit⊕ ⟩
                 c
                    QED

eq⊕' : CancellativeR _⊕_
eq⊕' {a} {b} {c} eq =

                 a
                    ⟨ sym ⊕unit ⟩
                 a ⊕ unit
                    ⟨ cong2L _⊕_ (sym ⊕inverse) ⟩
                 a ⊕ (c ⊕ inverse c)
                    ⟨ sym assoc ⟩
                 (a ⊕ c) ⊕ inverse c
                    ⟨ cong2R _⊕_ eq ⟩
                 (b ⊕ c) ⊕ inverse c
                    ⟨ assoc ⟩
                 b ⊕ (c ⊕ inverse c)
                    ⟨ cong2L _⊕_ ⊕inverse ⟩
                 b ⊕ unit
                    ⟨ ⊕unit ⟩
                 b
                    QED

import Cancellative
open Cancellative _⊕_ ⊕eq' eq⊕' public