{-# OPTIONS --type-in-type #-}

open import NeilPrelude


module Ring {A : Set}

       (_⊕_     : Op A)
       (⊕assoc  : Associative _⊕_)
       (⊕comm   : Commutative _⊕_)
      
       (zero   : A)
       (unit⊕  : UnitL zero _⊕_)

       (inverse  : A → A)
       (⊕inverse : InverseR inverse zero _⊕_)

       (_⊗_     : Op A)
       (⊗assoc  : Associative _⊗_)

       (distrL : DistributiveL _⊗_ _⊕_)
       (distrR : DistributiveR _⊗_ _⊕_)

  where

import CommGroup
open CommGroup _⊕_ ⊕assoc ⊕comm zero unit⊕ inverse ⊕inverse public

import Equational
open Equational _≡_ refl trans

⊗zero : ZeroR zero _⊗_
⊗zero {a} = ⊕canc

            ((a ⊗ zero) ⊕ (a ⊗ zero)
                ⟨ sym distrL ⟩
             a ⊗ (zero ⊕ zero)
                ⟨ cong2L _⊗_ unit⊕ ⟩
             a ⊗ zero 
                ⟨ sym ⊕unit ⟩
             (a ⊗ zero) ⊕ zero
                QED)

zero⊗ : ZeroL zero _⊗_
zero⊗ {a} = ⊕canc {zero ⊗ a}

            ((zero ⊗ a) ⊕ (zero ⊗ a)
                ⟨ sym distrR ⟩
             (zero ⊕ zero) ⊗ a
                ⟨ cong2R _⊗_ unit⊕ ⟩
             zero ⊗ a 
                ⟨ sym ⊕unit ⟩
             (zero ⊗ a) ⊕ zero
                QED)

import SemiRing
open SemiRing _⊕_ ⊕assoc ⊕comm zero unit⊕ _⊗_ ⊗assoc zero⊗ ⊗zero distrL distrR


