{-# OPTIONS --type-in-type #-}

open import NeilPrelude


module RingUnity {A : Set}

       (_⊕_      : A → A → A)
       (⊕assoc   : Associative _⊕_)
       (⊕comm    : Commutative _⊕_)

       (zero     : A)
       (unit⊕    : UnitL zero _⊕_)

       (inverse  : A → A)
       (⊕inverse : InverseR inverse zero _⊕_)

       (_⊗_      : A → A → A)
       (⊗assoc   : Associative _⊗_)

       (one      : A)
       (unit⊗    : UnitL one _⊗_)
       (⊗unit    : UnitR one _⊗_)

       (distrL : DistributiveL _⊗_ _⊕_)
       (distrR : DistributiveR _⊗_ _⊕_)

  where

import Ring
open Ring _⊕_ ⊕assoc ⊕comm zero unit⊕ inverse ⊕inverse _⊗_ ⊗assoc distrL distrR public

import SemiRingUnity
open SemiRingUnity _⊕_ ⊕assoc ⊕comm zero unit⊕ _⊗_ ⊗assoc zero⊗ ⊗zero one unit⊗ ⊗unit distrL distrR


