{-# OPTIONS --type-in-type #-}

open import NeilPrelude
open import Properties

module SemiRing {A : Set}

       (_⊕_    : Op A)
       (⊕assoc : Associative _⊕_)
       (⊕comm  : Commutative _⊕_)

       (zero  : A)
       (unit⊕ : UnitL zero _⊕_)

       (_⊗_    : Op A)
       (⊗assoc : Associative _⊗_)

       (zero⊗ : ZeroL zero _⊗_)
       (⊗zero : ZeroR zero _⊗_)

       (distrL : DistributiveL _⊗_ _⊕_)
       (distrR : DistributiveR _⊗_ _⊕_)

  where

distr : {a b c : A} → a ⊗ (b ⊕ c) ≡ (a ⊗ b) ⊕ (a ⊗ c)
distr = distrL

import CommMonoid
open CommMonoid _⊕_ ⊕assoc ⊕comm zero unit⊕ public

import SemiGroup
open SemiGroup _⊗_ ⊗assoc

lem-[a⊕0]⊗b=a⊗b : {a b : A} → (a ⊕ zero) ⊗ b ≡ a ⊗ b
lem-[a⊕0]⊗b=a⊗b = cong2R _⊗_ ⊕unit
