{-# OPTIONS --type-in-type #-}

open import NeilPrelude
open import Properties

module SemiRingUnity {A : Set}

       (_⊕_    : Op A)
       (⊕assoc : Associative _⊕_)
       (⊕comm  : Commutative _⊕_)

       (zero  : A)
       (unit⊕ : UnitL zero _⊕_)

       (_⊗_    : Op A)
       (⊗assoc : Associative _⊗_)
       (zero⊗  : ZeroL zero _⊗_)
       (⊗zero  : ZeroR zero _⊗_)

       (one   : A)
       (unit⊗ : UnitL one _⊗_)
       (⊗unit : UnitR one _⊗_)

       (distrL : DistributiveL _⊗_ _⊕_)
       (distrR : DistributiveR _⊗_ _⊕_)
  where

import SemiRing
open SemiRing _⊕_ ⊕assoc ⊕comm zero unit⊕ _⊗_ ⊗assoc zero⊗ ⊗zero distrL distrR public

import Monoid
open Monoid _⊗_ ⊗assoc one